#!/bin/bash
# annoy.mod.sh
# -------------
# Dulog module.
# weed out some annoying messages, but make a note of it in the report.
# by Icon Riabitsev <icon@phy.duke.edu>
#
# $Id: annoy.mod.sh,v 1.3 2001/08/15 17:43:26 icon Exp $
#

getboxlist() {
 # $1 should be the file name with log entries
 # produces the list and puts it into $WORKPREFIX.report
 sed "s/.* \([^[:space:]]*\) kernel:.*/\1/g; s|/.*||g" $1 | sort | uniq >> $WORKPREFIX.report
}

WORKPREFIX="$TMPPREFIX.annoy"

# look for floppy reports

egrep "02:00: rw=0, want=13, limit=4" $LOGCAT > $WORKPREFIX.flops
if [ -s $WORKPREFIX.flops ]; then
 echo "::Dirty floppy mounts on::" >> $WORKPREFIX.report
 getboxlist $WORKPREFIX.flops
 if [ ! -z "$WEED" ]; then
  sed ': more
      $!N
      s/\n/&/2;
      t enough
      $!b more
      : enough
      /^.*kernel: 02:00: rw.*want.*limit.*\n.*Directory sread.*\n.*beyond end of dev.*$/d
      P;D' $LOGCAT > $LOGCAT.new
  mv $LOGCAT.new $LOGCAT
 fi
fi

#look for CD-ROM loads/unloads
egrep "kernel: Uniform CD-ROM" $LOGCAT > $WORKPREFIX.cdrom
egrep "kernel:.*ATAPI.*CD-ROM" $LOGCAT >> $WORKPREFIX.cdrom
if [ -s $WORKPREFIX.cdrom ]; then
 echo "::CD-ROM activity on::" >> $WORKPREFIX.report
 getboxlist $WORKPREFIX.cdrom
 if [ ! -z "$WEED" ]; then
  egrep -v "kernel: Uniform CD-ROM" $LOGCAT > $WORKPREFIX.1
  egrep -v "kernel:.*ATAPI.*CD-ROM" $WORKPREFIX.1 > $LOGCAT
 fi
fi

#look for SoundBlaster stuff.
egrep "kernel: [Ss][Bb]" $LOGCAT > $WORKPREFIX.sb
if [ -s $WORKPREFIX.sb ]; then
 echo "::SoundBlaster activity on::" >>  $WORKPREFIX.report
 getboxlist $WORKPREFIX.sb
 if [ ! -z "$WEED" ]; then
  egrep -v "kernel: [Ss][Bb]" $LOGCAT > $LOGCAT.new
  mv $LOGCAT.new $LOGCAT
 fi
fi

# look for IRQ finds
egrep "kernel: PCI: Found IRQ" $LOGCAT > $WORKPREFIX.irq
if [ -s $WORKPREFIX.irq ]; then
 echo "::PCI IRQ finds on::" >> $WORKPREFIX.report
 getboxlist $WORKPREFIX.irq
 if [ ! -z "$WEED" ]; then
  egrep -v "kernel: PCI: Found IRQ" $LOGCAT > $LOGCAT.new
  mv $LOGCAT.new $LOGCAT
 fi
fi

if [ -s $WORKPREFIX.report ]; then
 echo -e "\nANNOYANCES\n-------------" >> $LOGREPORT
 cat $WORKPREFIX.report >> $LOGREPORT
fi
